
/*
 * LIB/NODE.C	- Simple string node routines
 *
 *
 * (c)Copyright 1997, Matthew Dillon, All Rights Reserved.  Refer to
 *    the COPYRIGHT file in the base directory of this distribution 
 *    for specific rights granted.
 *
 */

#include "defs.h"

Prototype void FreeNodeList(Node **pnode);
Prototype Node *MakeNode(const char *str, int val);
Prototype Node *MakeNode2(const char *str1, const char *str2, int val);

void
FreeNodeList(Node **pnode)
{
    Node *no;

    while ((no = *pnode) != NULL) {
	*pnode = no->no_Next;
	free(no);
    }
}

Node *
MakeNode(const char *str, int val)
{
    Node *node = malloc(sizeof(Node) + strlen(str) + 1);
    node->no_Next = NULL;
    node->no_Name = (char *)(node + 1);
    strcpy(node->no_Name, str);
    node->no_Value = val;
    return(node);
}

Node *
MakeNode2(const char *str1, const char *str2, int val)
{
    Node *node = malloc(sizeof(Node) + strlen(str1) + strlen(str2) + 2);

    node->no_Next = NULL;
    node->no_Name = (char *)(node + 1);
    node->no_Name2 = node->no_Name + strlen(str1) + 1;
    strcpy(node->no_Name, str1);
    strcpy(node->no_Name2, str2);
    node->no_Value = val;

    return(node);
}

